#include "Platform.hxx"
#include "PalmOSAPI.hxx"
#include "EndianUtils.h"

//#include "CoreTraps.h"

#define sysTrapMemChunkFree			0xA012
#define sysTrapMemPtrNew			0xA013
#define sysTrapMemCmp				0xA2D7
#define sysTrapMemMove				0xA026
#define sysTrapStrNCaselessCompare	0xA2EE
#define sysTrapStrChr				0xA0CC
#define sysTrapStrLen				0xA0C7
#define sysTrapStrCopy				0xA0C5
#define sysTrapFrmCustomAlert		0xA194

PalmOSAPI::PalmOSAPI( const void*		pEmulState,
					  Call68KFuncType*	pCall68KFunc ) : m_pEmulState( pEmulState ),
														 m_pCall68KFunc( pCall68KFunc ) {
}

/*
MemPtr PalmOSAPI::MemPtrNew( UInt32 size ) {
	size = ByteSwap32( size );
	MemPtr p = reinterpret_cast<MemPtr>( m_pCall68KFunc( m_pEmulState,
														 PceNativeTrapNo( sysTrapMemPtrNew ),
														 &size, 4 | kPceNativeWantA0) );
	return p;
} 
*/

/*
Err PalmOSAPI::MemPtrFree( MemPtr p ) {
	p = reinterpret_cast<MemPtr>( ByteSwap32( p ) );
	Err ret = m_pCall68KFunc( m_pEmulState, PceNativeTrapNo( sysTrapMemChunkFree ), &p, 4 );
	return ret;
}
*/
/*
Err PalmOSAPI::MemMove( void* pDest, const void* pSrc, Int32 numBytes ) {
	UInt32 args[3];
	args[0] = ByteSwap32( pDest );
	args[1] = ByteSwap32( pSrc );
	args[2] = ByteSwap32( numBytes );
	Err ret = m_pCall68KFunc( m_pEmulState, PceNativeTrapNo( sysTrapMemMove ), args, 12 );
	return ret;
}
*/
/*
Int16 PalmOSAPI::MemCmp( const char* s1, const char* s2, Int32 n ) {
	UInt32 args[3];
	args[0] = ByteSwap32( s1 );
	args[1] = ByteSwap32( s2 );
	args[2] = ByteSwap32( n );
	Int16 ret = m_pCall68KFunc( m_pEmulState, PceNativeTrapNo( sysTrapMemCmp ), args, 12 );
	return ret;
}
*/
/*
Int16 PalmOSAPI::StrNCaselessCompare( const char* s1, const char* s2, Int32 n ) {
	UInt32 args[3];
	args[0] = ByteSwap32( s1 );
	args[1] = ByteSwap32( s2 );
	args[2] = ByteSwap32( n );
	Int16 ret = m_pCall68KFunc( m_pEmulState, PceNativeTrapNo( sysTrapStrNCaselessCompare ), args, 12 );
	return ret;
}
*/
/*
const char* PalmOSAPI::StrChr( const char* p, char c ) {
	p = reinterpret_cast<const char*>( ByteSwap32( p ) );
	const char* ret = reinterpret_cast<const char*>( m_pCall68KFunc( m_pEmulState,
																	 PceNativeTrapNo( sysTrapStrChr ),
																	 &p, 5 | kPceNativeWantA0 ) );
	return ret;
}
*/
/*
unsigned int PalmOSAPI::StrLen( const char* s ) {
	s = reinterpret_cast<const char*>( ByteSwap32( s ) );
	unsigned int ret = m_pCall68KFunc( m_pEmulState, PceNativeTrapNo( sysTrapStrLen ), &s, 4 );
	return ret;
}
*/
/*
char* PalmOSAPI::StrCopy( char* dest, const char* src ) {
	dest = reinterpret_cast<char*>( ByteSwap32( dest ) );
	src = reinterpret_cast<const char*>( ByteSwap32( src ) );
	char* ret = reinterpret_cast<char*>( m_pCall68KFunc( m_pEmulState,
														 PceNativeTrapNo( sysTrapStrCopy ),
														 &dest, 8 | kPceNativeWantA0 ) );
	return ret;
}
*/

UInt16 PalmOSAPI::FrmCustomAlert( UInt16 alertId, const char *s1, const char *s2, const char *s3 ) {

	struct {
		union {
			UInt32	dummy1;
			UInt16	id[2];
		};
		const char* ps1;
		const char* ps2;
		const char* ps3;
	} param;

	param.id[1]	= ByteSwap16( alertId );
	param.ps1	= reinterpret_cast<const char*>( ByteSwap32( s1 ) );
	param.ps2	= reinterpret_cast<const char*>( ByteSwap32( s2 ) );
	param.ps3	= reinterpret_cast<const char*>( ByteSwap32( s3 ) );

	UInt16 ret = m_pCall68KFunc( m_pEmulState, PceNativeTrapNo( sysTrapFrmCustomAlert ), &(param.id[1]), 14 );
	return ret;

}
